package org.apache.maven.model.converter;

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

import org.apache.maven.model.Model;

import java.util.List;

/**
 * Model conversion interface.
 *
 * @author <a href="mailto:brett@apache.org">Brett Porter</a>
 * @version $Id: ModelConverter.java 514216 2007-03-03 18:32:26Z dennisl $
 */
public interface ModelConverter
{
    String ROLE = ModelConverter.class.getName();

    Model translate( org.apache.maven.model.v3_0_0.Model v3Model )
        throws PomTranslationException;

    void validateV4Basics( Model model, String groupId, String artifactId, String version, String packaging );

    List getWarnings();
}
